import g9 from "g9"

var data = {
    "time": 72
}

function render(data, ctx){
    var r = 100,
        m = 70;
    
    // minute hand
    ctx.line(0, 0, Math.cos(data.time / 60) * m, Math.sin(data.time / 60) * m, {
        'stroke-width': 10,
        'stroke-linecap': 'round',
        'stroke': 'gray'
    })
    
    // second hand
    ctx.line(0, 0, Math.cos(data.time) * r, Math.sin(data.time) * r, {
        'stroke-width': 10,
        'stroke-linecap': 'round'
    })
    
    ctx.circle(0, 0, { r: 120, fill: 'none', stroke: 'black' })
}

var graphics = g9(data, render)
    .insertInto('#root')

setInterval(function(){
    if(!graphics.isManipulating()){
        var data = graphics.getData()
        data.time += 0.01
        graphics.setData(data)    
    }
}, 50)


