import g9 from "g9"

var data = {
    "time": 72
}

function render(data, ctx){
    var crank = 40;
    var shaft = 120
    
    // housing
    var fill = 'hsl('+ (Math.cos(data.time) * 60 + 300) +', 100%, 90%)'
    ctx.rect(-40, 0, 80, -235, { fill: fill, stroke: 'black' })
    ctx.circle(0, 0, { r: 70, fill: 'white', stroke: 'black' })
    
    
    var CrankAngle = Math.asin(crank * Math.cos(data.time) / shaft)
    var OppositeAngle = Math.PI - (CrankAngle + data.time);
    var Y = shaft * Math.cos(OppositeAngle) / Math.cos(data.time)
    
    // shaft
    ctx.line(Math.cos(data.time) * crank, Math.sin(data.time) * crank, 0, Y, {
        'stroke-width': 10,
        'stroke': 'gray',
        'stroke-linecap': 'round'
    })
    
    
    // crank
    ctx.line(0, 0, Math.cos(data.time) * crank, Math.sin(data.time) * crank, {
        'stroke-width': 40,
        'stroke': 'black',
        'stroke-linecap': 'round'
    })
    
    
    // piston
    ctx.line(0, Y, 0, Y - 70, {
        'stroke-width': 70,
        'stroke': 'gray',
    })   
}

var graphics = g9(data, render)
    .insertInto('#root')

setInterval(function(){
    if(!graphics.isManipulating()){
        var data = graphics.getData()
        data.time += 0.05
        graphics.setData(data)    
    }
}, 10)


