import g9 from "g9"

var data = {
    r: 20,
    theta: 144
}


function render(data, ctx){
    var t = make_turtle(ctx);
    
    for(var i = 0; i < 30; i++){
        t.forward(i * data.r, { 'stroke-width': 5 })
        t.dturn(data.theta)
    }
}

function make_turtle(ctx){
    var t = 0, x = 0, y = 0;
    return {
        turn(angle){ t += angle },
        dturn(deg){ t += deg / (180 / Math.PI)},
        forward(amount, options = {}){
            var new_x = x + amount * Math.cos(t),
                new_y = y + amount * Math.sin(t);
            if(options) ctx.line(x, y, new_x, new_y, options);
            x = new_x; y = new_y;
        }
    }
}


g9(data, render)
    .insertInto('#root')