// stick-person

import g9 from "g9"

var data = {
    armth: 1.1,
    legth: 1.1,
    headr: 40,
    x: 0,
    y: 0
}

function render(data, ctx){
    var x = data.x,
        y = data.y;
    
    ctx.circle(x, y, {
        stroke: "black",
        fill: "none",
        r: 40, 
        'stroke-width': 5
    })
    
    ctx.line(x, y + 40, x, y + 150, {
        'stroke-width': 5
    })
    
    var legth = Math.max(-1, Math.min(1.5, data.legth)),
        leg = 80;
    
    ctx.line(x, y + 150, x + leg * Math.cos(legth), y + 150 + leg * Math.sin(legth), {
        'stroke-width': 5,
        affects: ['legth']
    })
    ctx.line(x, y + 150, x - leg * Math.cos(legth), y + 150 + leg * Math.sin(legth), {
        'stroke-width': 5,
        affects: ['legth']
    })
    
    
    var armth = Math.max(-0.5, Math.min(1.5, data.armth)),
        arm = 80;
    
    ctx.line(x, y + 50, x + arm * Math.cos(armth), y + 50 + arm * Math.sin(armth), {
        'stroke-width': 5,
        affects: ['armth']
    })
    ctx.line(x, y + 50, x - arm * Math.cos(armth), y + 50 + arm * Math.sin(armth), {
        'stroke-width': 5,
        affects: ['armth']
    })
    
}


var graphics = g9(data, render)
    .insertInto('#root')


