// nonlinear grid warping ported from Carbide/Watlab

import g9 from "g9"

var data = {
    "spin": 0,
    "scale": 1
}

function render(data, ctx){
    function warp(dx, dy){
        var r  = Math.sqrt(dx * dx + dy * dy)
        var theta = Math.atan2(dy, dx)
        return [
            data.scale * r * Math.cos(theta + data.spin * r),
            data.scale * r * Math.sin(theta + data.spin * r)
        ]
    }
    
    var drawWarpedCircle = ctx.pure(function(i, j){
        var out = warp(i, j)
        ctx.circle(30 * out[0], 30 * out[1])
    })
    for(var i = -10; i <= 10; i++){
        for(var j = -10; j <= 10; j++){
            drawWarpedCircle(i, j)    
        }
    }
}

var graphics = g9(data, render)
    .insertInto('#root')


